#ifndef INCLUDED_UNIQUE_COLOR_GENERATOR_H
#define INCLUDED_UNIQUE_COLOR_GENERATOR_H

// g++ doesn't support auto_ptr
#ifdef WIN32
#include "Singleton.h"
#endif

#include <vector>

#include "Color.h"

using namespace std;

#ifndef WIN32
class UniqueColorGenerator;

class UniqueColorGenerator  
#else
class UniqueColorGenerator : public Singleton<UniqueColorGenerator>
#endif
{
	public:

		UniqueColorGenerator(void);

		Color getUniqueColor(void);

#ifndef WIN32
		static UniqueColorGenerator * getInstance(void) 
		{
			if (m_instance == NULL)
			{
				m_instance = new UniqueColorGenerator();
			}

			return m_instance;
		}
#endif

	private:

		vector<Color> m_generated_colors;

		unsigned int m_next_color_to_give;

#ifndef WIN32
		static UniqueColorGenerator *m_instance;
#endif
};

#endif


